#include <p18f4620.h>
#include <usart.h>
#include <delays.h>

 
// INTIO67 configures internal oscillator

#pragma config OSC=INTIO67, LVP=OFF, MCLRE=ON , WDT=OFF
 
void setup(void)
{
	/* Clock Setup*/ 
	OSCCON = 0b01110010; //select 8 MHz clock 

	/* Port Set Up*/
	ADCON1 = 0b00001111; //set all pins to digital mode
	TRISD = 0x00;
	TRISA = 0x00;
	TRISB = 0b00000000; 
	TRISC = 0b10000000; // RX is an input, TX is output


	/* Interrupt Setup */
	INTCON = 0x00; /* Clear Registers */
	PIR1 = 0x00;
	PIE1 = 0x00;
	

  // Turn on the 4 LEDs
 // Microchip recommends writing to the PORT Latch rather than the PORT Pins 
	LATBbits.LATB0=1;
	LATBbits.LATB1=1;
	LATBbits.LATB2=1;
	LATBbits.LATB3=1;

    


	
 
}	
 

void main(void)
{
    int n;
    const MEM_MODEL rom char * crp = " Hello World! ";

	setup();

  while(1)
  {
    n = 12;

	while (n--)
	{
	
		Delay10KTCYx(100);

                // Blink the 4 LEDs
               // Microchip recommends writing to the PORT Latch rather than the PORT Pins 
	       LATBbits.LATB0 = ~LATBbits.LATB0;
	       LATBbits.LATB1 = ~LATBbits.LATB1;
	       LATBbits.LATB2 = ~LATBbits.LATB2;
	       LATBbits.LATB3 = ~LATBbits.LATB3;

		
	}

   OpenUSART (USART_TX_INT_OFF & USART_RX_INT_OFF & USART_ASYNCH_MODE & USART_EIGHT_BIT & USART_CONT_RX & USART_BRGH_LOW, 12);

   n = 150;

	while (n--)
	{
	
		Delay10KTCYx(100);

        putrsUSART(crp);
	

		
	}

    CloseUSART();
  }

}